#!/bin/sh
#
# Ez a script GNU/GPL licensz, mindenki hasznlja egszsggel.
# A script esetleges hibs mkdse ltal okozott hibkrt felelssget
# nem vllalok. Mindenki _csak_ sajt felelssgre hasznlhatja.
# A script korntsem tkletes, ha valamilyen javtand hibt,
# vagy hinyossgot tallsz benne, krlek rtests a szimszon@freemail.hu cmen.
# 
# A script els paramtereknt a Chip Magazin azon katalogust kell megadni
# amely egy sima szvegfile, nincs tmrtve, s a mezelvlaszt karakterek
# > (csrk). Illetve a scriptet trva, a DEFFILE vltozban megadhat a file
# helye.
# 
# v.0.6 - 2001.01.04.
# Ksztette: Gyuris Szabolcs J.
#
PID=$$
TMP1="/tmp/chip.$PID.tmp1"                # Az els ideiglenes llomny amit ltrehoz
TMP2="/tmp/chip.$PID.tmp2"                # A msodik
DEFFILE="/cdrom/cd_keres/chipcds4.txt" # A file alaprtelmezett helye
HELPFILE="chip_help.txt"                 # A programhoz val segitsget nyjt szvegfile
FILE=$1                                  # Az els paramter tadsa
MENU=0
KERES=""                                 # Kereskifejezs
NEM=""                                   # s amit nem keres
CAPS="KI"                                # figyelje-e a nagy/kisbetket
HIBA=0                                   # cancel = 1
FMENT=""                                 # a tallatok mentshez a file neve
CHECK="1 2 3"                            # oszlopokban valo kereses
RENDEZ="Rendezetlen"			 # Rendezs tpusa
RENDEZ_TMP="File_neve < off File_lersa < off CD_szma < off Rendezetlen < on"
					 # Rendezsi lista
BACKTITLE="Chip Magazin CD tartalomjegyzk bngsz v.0.6 | adatbzis: "
					 # Program fejlc
# Windows szr
# \232 - 
# \032 - passz
# \217 - 
# \226 - 
# \227 - 
# \234 - 
# \204 - passz
#tr '\232' '' \| tr '\032' ' ' \| tr '\217' '' \| tr '\226' '' \| tr '\227' '' \| tr '\234' '' \| tr '\204' '?'


if [ $FILE = "--help" ] 2> /dev/null; then
  echo "Keresprogram a Chip Szmtgpmagazin CD mellklet katalgust"
  echo "tartalmaz adatbzishoz, verzi: 0.6"
  echo "Az adatbzisnak szveges llomnynak kell lennie, amiben a klnbz"   
  echo "oszlopokat \">\" (csrk) vlasztjk el egymstl. Valamint az llomny"
  echo "ne legyen tmrtve. Ilyen pldul a \"chipcds4.txt\" llomny"         
  echo "Hasznlata:"
  echo " "
  echo "chip_keres.sh [ut/adatbzis_neve | --help]"
  echo " "
  echo "Abban az esetben, ha nem adunk meg adatbzisnevet, akkor az alaprtel-"
  echo "mezett \"$DEFFILE\"-t prblja hasznlni." 
  echo "Ha gysem tallta meg, akkor a program r fog krdezni indtskor."
  echo "Az alaprtelmezett helyet egyszeren meg lehet vltoztatni egy "
  echo "szvegszerkesztvel, csak meg kell nyitni a chip_keres.sh-t vele, s trni"
  echo "a DEFFILE nev vltoz rtkt a megfelelre."
  echo "A programot mindenki csak sajt felelssgre hasznlja!"
  exit 0
fi

if ! [ -e $HELPFILE ]; then
  echo "Nem tallom a $HELPFILE-t :("
  echo "ENTER a tovbblpshez, CTRL+C a megszaktshoz"
  read
fi # ! [ -e $HELPFILE ]
if [ -z $FILE ] || ! [ -e $FILE ]; then
    if [ -e $DEFFILE ]; then
      FILE=$DEFFILE
    else
      FILE=$DEFFILE
      until [ -e $FILE ] || ! [ $HIBA = 0 ]
      do
        dialog --inputbox "Hol tallhat az adatbzis?" 8 70 "$FILE" 2> $TMP1
        HIBA=$?
        FILE=$(cat $TMP1)
      done # [ -e $FILE ] || ! [ $HIBA = 0 ]
      if ! [ $HIBA = 0 ]; then 
        echo "Nincs feldolgozand file... :("
        exit 1
      fi # [ $HIBA ]
    fi #[ -e $DEFFILE ]
fi # [ -z $FILE ]
EV=`find $FILE -printf '%TY'`               # Hanyadik v
HONAP=`find $FILE -printf '%Tm'`            # Honap
NAP=`find $FILE -printf '%Td'`              # Nap
ORA=`find $FILE -printf '%Tk'`              # Ora
PERC=`find $FILE -printf '%TM'`             # Perc
BACKTITLE="$BACKTITLE$EV.$HONAP.$NAP. $ORA:$PERC"

if file $FILE | grep "gzip compressed" >/dev/null; then
  CAT="zcat"
else
    CAT="cat"
fi
    

until [ $MENU = 4 ];
do
  dialog --backtitle "$BACKTITLE"\
  --menu Keress 17 60 9\
  1 "Amit keres -> $(echo "$KERES" | head -c 30 )"\
  2 "Amit nem keres -> $(echo "$NEM" | head -c 30 )"\
  3 "Keress ->"\
  4 "Kilps"\
  5 "Kis/nagybetk -> $CAPS"\
  6 "Keressek a(z) $CHECK oszlopokban"\
  7 "Rendezs -> $RENDEZ"\
  8 "Fileba ments -> $(echo "$FMENT" | head -c 30 )"\
  9 "Segtsg" 2> $TMP1
  MENU=$(cat $TMP1)
  if [ -z $MENU ]; then
    MENU=4
  fi # [ -z $MENU ]
  clear
  case $MENU in
    1) dialog --backtitle "$BACKTITLE"\
       --inputbox "Mit keressen?" 8 70 "$KERES" 2> $TMP1
       if ! [ $? -eq 1 ]; then 
         KERES=$(cat $TMP1)
       fi;;
    2) dialog --backtitle "$BACKTITLE"\
       --inputbox "Mit ne keressen?" 8 70 "$NEM" 2> $TMP1
       if ! [ $? -eq 1 ]; then
         NEM=$(cat $TMP1)
       fi;; # ! [ $? -eq 1 ]
    3) echo -en "A keress folyamatban van [. ]\r"
       if [ $CAPS = "BE" ]; then
         $CAT $FILE | tr '\232' '' | tr '\032' ' ' | tr '\217' '' | tr '\226' '' |\
		       tr '\227' '' | tr '\234' '' | tr '\204' '?' |\
	  awk -F ">" -v k="$CHECK" -v mit="$KERES" -v nem="$NEM"\
        '{ gsub(/\r/,"") }
        { if (( k ~ "1" && $1 ~ mit )\
        || ( k ~ "2" && $2 ~ mit )\
        || ( k ~ "3" && $3 ~ mit )\
        || ( k ~ "1 2 3" && $0 ~ mit )) {
        if ( nem == "" || $0 !~ nem ) \
        { print  $1">"$2">"$3 } } }' > $TMP2
       else
          $CAT $FILE | tr '\232' '' | tr '\032' ' ' | tr '\217' '' | tr '\226' '' |\
		       tr '\227' '' | tr '\234' '' | tr '\204' '?' |\
 	   awk -F \> -v k="$CHECK" -v mit="$KERES" -v nem="$NEM"\
        'BEGIN { 
        mit = tolower(mit)
        nem = tolower(nem)
	}
        { gsub(/\r/,"") }
        { if (( k ~ "1" && tolower($1) ~ mit )\
        || ( k ~ "2" && tolower($2) ~ mit )\
        || ( k ~ "3" && tolower($3) ~ mit )\
        || ( k ~ "1 2 3" && tolower($0) ~ mit )) {
        if ( nem == "" || tolower($0) !~ nem )\
        { print  $1">"$2">"$3 } } }' > $TMP2
       fi # [ $CAPS = "BE" ]
       echo -en "Rendezs folyamatban van  [..]\r"
       case $RENDEZ in
	 "File_neve") cat $TMP2 | sort -t\> +0 > $TMP1;;
	 "File_lersa") cat $TMP2 | sort -t\> +1 > $TMP1;;
	 "CD_szma") cat $TMP2 | sort -t\> +2 > $TMP1;;
	 "Rendezetlen") cp $TMP2 $TMP1;;
       esac
       cat "$TMP1" | awk '{gsub(/\|/,"\t"); print $0}' > $TMP2       
       if ! [ -z "$FMENT" ]; then
         cp $TMP2 $FMENT
       fi # ! [ -z "$FMENT" ];
       X=500
       Y=500
       echo "Rendezs folyamatban van  [OK]"
       dialog --textbox $TMP2 $Y $X 2> $TMP1
       Y_M=$(cat $TMP1 | awk '{gsub(/C.+\(\-/,""); gsub(/,.+/,""); print $0 }') #'
       X_M=$(cat $TMP1 | awk '{gsub(/.+\(\-[0-9]+,\-/,""); gsub(/\).+/,""); print $0 }') #'
       let "X=$X-($X_M*2)"
       let "Y=$Y-($Y_M*2)-3"       
       dialog --clear --backtitle "File nv | Meghatrozs | Chip CD szma s knyvtr"\
       --textbox "$TMP2" $Y $X
       dialog --clear;;
    5) if [ $CAPS = "KI" ]; then
         CAPS="BE"
       else
         CAPS="KI"
       fi;; # [ $CAPS = "KI"]
    6) dialog --backtitle "Chip Magazin CD tartalomjegyzk bngsz v.0.5 | adatbzis: $EV.$HONAP.$NAP. $ORA:$PERC"\
        --checklist "Milyen oszlopokban keressen?" 10 70 3 \
       1 "File neve" on 2 "Megjegyzs" on 3 "CD sorszm" on 2> $TMP1
       if ! [ $? -eq 1 ]; then
         CHECK=$(cat $TMP1 | tr -d \")
       fi;; # ! [ $? -eq 1 ];
    7) dialog --backtitle "$BACKTITLE"\
       --radiolist "Milyen oszlopra rendezzen?" 12 70 4 $RENDEZ_TMP 2> $TMP1
       if ! [ $? -eq 1 ]; then                                                  
         RENDEZ=$(cat $TMP1 | tr -d \")                                       
         RENDEZ_TMP=$(echo "$RENDEZ_TMP" | awk '{ gsub(/on|off/,"\n"); print $0 }' |\
                      awk -v x="$RENDEZ" '{gsub(/[ ]/,"_",x)}\
                      {if ( $0 ~ x && length($0) != 0 ) { print $0"on"}\
                       if ( $0 !~ x && length($0) != 0 ) { print $0"off"}}') #'
       fi;; # ! [ $? -eq 1 ];
    8) dialog --backtitle "$BACKTITLE"\
       --inputbox "                     Mi legyen a file neve?\n\
        Ha res stringet adsz meg, akkor nem lesz ments." 10 70 "$NEM" 2> $TMP1
       if ! [ $? -eq 1 ]; then
         FMENT=$(cat $TMP1)
       fi;; # ! [ $? -eq 1 ] 
    9) X=500
       Y=500
       dialog --textbox $HELPFILE $Y $X 2> $TMP1
       Y_M=$(cat $TMP1 | awk '{gsub(/C.+\(\-/,""); gsub(/,.+/,""); print $0 }') #'
       X_M=$(cat $TMP1 | awk '{gsub(/.+\(\-[0-9]+,\-/,""); gsub(/\).+/,""); print $0 }') #'
       let "X=$X-($X_M*2)"
       let "Y=$Y-($Y_M*2)-3"       
       dialog --clear --backtitle "$BACKTITLE"\
       --textbox $HELPFILE $Y $X;;   
  esac # $MENU in
done # [ $MENU = 4 ];
rm $TMP1 2> /dev/null
rm $TMP2 2> /dev/null
